import { DependencyContainer } from "./DependencyContainer";
import { LocalStorageService } from "./Services/LocalStorageService";
import { ExalusConnectionService } from './Services/ExalusConnectionService';
import { WebApiCacheService } from "./Services/WebApi/WebApiCacheService";
import { UsersService } from "./Services/Users/UsersService";
import { DevicesService } from "./Services/Devices/DevicesService";
import { SessionService } from "./Services/Session/SessionService";
var Api = (function () {
    function Api() {
    }
    Api.Init = function () {
        if (DependencyContainer.IsInitialized)
            return;
        var dep = DependencyContainer.Instance;
        try {
            dep.RegisterService(new LocalStorageService());
            dep.RegisterService(new WebApiCacheService());
            dep.RegisterService(new ExalusConnectionService());
            dep.RegisterService(new SessionService());
            dep.RegisterService(new UsersService());
            dep.RegisterService(new DevicesService());
        }
        catch (ex) {
            console.error(ex);
        }
    };
    Api.GetAsync = function (classType, cancelationToken) {
        return DependencyContainer.Instance.GetServiceAsync(classType, cancelationToken);
    };
    Api.GetWithTimeoutAsync = function (classType, timeout) {
        return DependencyContainer.Instance.GetServiceWithTimeoutAsync(classType, timeout);
    };
    Api.Get = function (classType) {
        return DependencyContainer.Instance.GetService(classType);
    };
    Api.Version = 1.0;
    return Api;
}());
export { Api };
//# sourceMappingURL=Api.js.map