import { Api } from './Api';
import { LoggerService } from './Services/Logging/LoggerService';
var Event = (function () {
    function Event() {
        this._log = Api.Get(LoggerService);
        this.handlers = [];
    }
    Event.prototype.Subscribe = function (handler) {
        this.handlers.push(handler);
    };
    Event.prototype.Unsubscribe = function (handler) {
        this.handlers = this.handlers.filter(function (h) { return h !== handler; });
    };
    Event.prototype.Invoke = function () {
        var _this = this;
        this.handlers.slice(0).forEach(function (h) {
            try {
                h();
            }
            catch (ex) {
                _this._log.Error(ex);
            }
        });
    };
    return Event;
}());
export { Event };
//# sourceMappingURL=Event.js.map