import { TypedEvent } from '../../TypedEvent';
import { CommunicationWay, DeviceState, DeviceType } from './IDevice';
var Device = (function () {
    function Device() {
        this._onDeviceStateChangedEvent = new TypedEvent();
        this._serialNumber = null;
        this._model = null;
        this._modelGuid = null;
        this._manufacturerGuid = null;
        this._isVirtual = false;
        this._isEnabled = false;
        this._deviceState = DeviceState.Working;
        this._deviceType = DeviceType.Unknown;
        this._communicationWay = CommunicationWay.OneWay;
        this._availableTasksTypes = [];
        this._availableResponseTypes = [];
        this._channels = [];
    }
    Device.prototype.OnDeviceStateChangedEvent = function () {
        return this._onDeviceStateChangedEvent;
    };
    Object.defineProperty(Device.prototype, "Guid", {
        get: function () {
            return this._guid == null ? "" : this._guid;
        },
        set: function (guid) {
            this._guid = guid;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Device.prototype, "Name", {
        get: function () {
            return this._name == null ? "" : this._name;
        },
        set: function (name) {
            this._name = name;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Device.prototype, "ChannelsAmount", {
        get: function () {
            return this._channelsAmount == null ? 0 : this._channelsAmount;
        },
        set: function (amount) {
            this._channelsAmount = amount;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Device.prototype, "SerialNumber", {
        get: function () {
            return this._serialNumber;
        },
        set: function (serialNumber) {
            this._serialNumber = serialNumber;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Device.prototype, "Model", {
        get: function () {
            return this._model;
        },
        set: function (model) {
            this._model = model;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Device.prototype, "ModelGuid", {
        get: function () {
            return this._modelGuid;
        },
        set: function (model) {
            this._modelGuid = model;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Device.prototype, "ManufacturerGuid", {
        get: function () {
            return this._manufacturerGuid;
        },
        set: function (manufacturerGuid) {
            this._manufacturerGuid = manufacturerGuid;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Device.prototype, "IsVirtual", {
        get: function () {
            return this._isVirtual;
        },
        set: function (isVirtual) {
            this._isVirtual = isVirtual;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Device.prototype, "IsEnabled", {
        get: function () {
            return this._isEnabled;
        },
        set: function (isEnabled) {
            this._isEnabled = isEnabled;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Device.prototype, "DeviceState", {
        get: function () {
            return this._deviceState;
        },
        set: function (deviceState) {
            this._deviceState = deviceState;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Device.prototype, "DeviceType", {
        get: function () {
            return this._deviceType;
        },
        set: function (deviceType) {
            this._deviceType = deviceType;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Device.prototype, "CommunicationWay", {
        get: function () {
            return this._communicationWay;
        },
        set: function (communicationWay) {
            this._communicationWay = communicationWay;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Device.prototype, "AvailableTaskTypes", {
        get: function () {
            return this._availableTasksTypes;
        },
        set: function (availableTasksTypes) {
            this._availableTasksTypes = availableTasksTypes;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Device.prototype, "AvailableResponseTypes", {
        get: function () {
            return this._availableResponseTypes;
        },
        set: function (availableResponseTypes) {
            this._availableResponseTypes = availableResponseTypes;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Device.prototype, "Channels", {
        get: function () {
            return this._channels;
        },
        enumerable: false,
        configurable: true
    });
    Device.prototype.ChangeDeviceNameAsync = function (name) {
        throw new Error('Method not implemented.');
    };
    Device.prototype.ExecuteTaskAsync = function (task, channel) {
        throw new Error('Method not implemented.');
    };
    return Device;
}());
export { Device };
//# sourceMappingURL=Device.js.map