var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { nameof } from 'ts-simple-nameof';
import { TypedEvent } from '../../TypedEvent';
import { DeviceState, CommunicationWay, DeviceType, DeviceTaskTypeInfo, DeviceResponseTypeInfo } from './IDevice';
import { ChannelConfigurations } from './IDeviceChannel';
import { Api } from '../../Api';
import { ExalusConnectionService } from '../ExalusConnectionService';
import { DependencyContainer } from '../../DependencyContainer';
import { DataFrame, Status, Method } from '../../DataFrame';
import { Device } from './Device';
var DevicesService = (function () {
    function DevicesService() {
        this._devices = [];
        this._serviceName = nameof(DevicesService);
        this._onDeviceFoundEvent = new TypedEvent();
        this._onDeviceRegisteredEvent = new TypedEvent();
        this._onDeviceRemovedEvent = new TypedEvent();
        this._onDeviceStateChangedEvent = new TypedEvent();
        this._connection = null;
        this._connection = Api.Get(ExalusConnectionService);
    }
    DevicesService.prototype.GetServiceName = function () {
        return this._serviceName;
    };
    DevicesService.prototype.SyncDevicesStatesAsync = function () {
        throw new Error('Method not implemented.');
    };
    DevicesService.prototype.OnDeviceStateChangedEvent = function () {
        return this._onDeviceStateChangedEvent;
    };
    DevicesService.prototype.OnDeviceRegisteredEvent = function () {
        return this._onDeviceRegisteredEvent;
    };
    DevicesService.prototype.OnDeviceRemovedEvent = function () {
        return this._onDeviceRemovedEvent;
    };
    DevicesService.prototype.OnDeviceFoundEvent = function () {
        return this._onDeviceFoundEvent;
    };
    DevicesService.prototype.GetDevicesAsync = function () {
        var _a, _b;
        return __awaiter(this, void 0, void 0, function () {
            var result, devices_1;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0: return [4, ((_a = this._connection) === null || _a === void 0 ? void 0 : _a.SendAndWaitForResponseAsync(new GetDevicesListRequest(), 5000, false))];
                    case 1:
                        result = _c.sent();
                        if (result == null)
                            return [2, []];
                        if (result.Status == Status.OK && result.Data != null) {
                            (_b = DependencyContainer.Log) === null || _b === void 0 ? void 0 : _b.Debug("Received ".concat(result.Data.length, " devices"));
                            devices_1 = [];
                            result.Data.forEach(function (element) {
                                var _a, _b, _c;
                                var device = new Device();
                                device.Guid = element.Guid;
                                device.Name = element.DeviceName;
                                device.ChannelsAmount = element.ChannelsNumber;
                                device.DeviceType = element.DeviceType;
                                device.CommunicationWay = element.CommunicationWay;
                                device.DeviceState = element.DeviceState;
                                device.IsEnabled = element.IsEnabled;
                                device.IsVirtual = element.IsVirtual;
                                device.SerialNumber = element.DeviceSerialNumber;
                                device.ManufacturerGuid = element.ManufacturerGuid;
                                device.ModelGuid = element.DeviceModelGuid;
                                device.Model = element.DeviceModel;
                                device.Name = element.DeviceName;
                                try {
                                    (_a = element.AvailableTasks) === null || _a === void 0 ? void 0 : _a.forEach(function (task) {
                                        var typeInfo = new DeviceTaskTypeInfo();
                                        typeInfo.InterfaceType = task;
                                        device.AvailableTaskTypes.push(typeInfo);
                                    });
                                    (_b = element.AvailableResponses) === null || _b === void 0 ? void 0 : _b.forEach(function (response) {
                                        var typeInfo = new DeviceResponseTypeInfo();
                                        typeInfo.InterfaceType = response;
                                        device.AvailableResponseTypes.push(typeInfo);
                                    });
                                }
                                catch (ex) {
                                    (_c = DependencyContainer.Log) === null || _c === void 0 ? void 0 : _c.Error(ex);
                                }
                                devices_1.push(device);
                            });
                            this._devices = devices_1;
                            return [2, devices_1];
                        }
                        return [2, []];
                }
            });
        });
    };
    DevicesService.prototype.GetDevice = function (guid) {
        return this._devices.find(function (a) { return a.Guid === guid; });
    };
    DevicesService.prototype.FindDevicesAsync = function (device) {
        throw new Error('Method not implemented.');
    };
    DevicesService.prototype.RegisterDeviceAsync = function (device) {
        throw new Error('Method not implemented.');
    };
    DevicesService.prototype.RemoveDeviceAsync = function (device) {
        throw new Error('Method not implemented.');
    };
    return DevicesService;
}());
export { DevicesService };
var DeviceObject = (function () {
    function DeviceObject() {
        this.Guid = "";
        this.CloudGuid = "";
        this.DeviceSerialNumber = "";
        this.DeviceModelGuid = "";
        this.ProtocolGuid = "";
        this.DeviceName = "";
        this.DeviceModel = "";
        this.ManufacturerGuid = "";
        this.ChannelsNumber = 0;
        this.IsVirtual = false;
        this.IsEnabled = false;
        this.DeviceState = DeviceState.Working;
        this.CommunicationWay = CommunicationWay.OneWay;
        this.DeviceType = DeviceType.Unknown;
        this.ChannelsConfigurations = [];
        this.Groups = [];
        this.AvailableTasks = [];
        this.AvailableResponses = [];
    }
    return DeviceObject;
}());
var DeviceGroupObject = (function () {
    function DeviceGroupObject() {
        this.Guid = "";
        this.Name = "";
    }
    return DeviceGroupObject;
}());
var ChannelConfigurationObject = (function () {
    function ChannelConfigurationObject() {
        this.Channel = 0;
        this.ChannelName = "";
        this.Configuration = ChannelConfigurations.Default;
        this.IconName = "";
        this.GroupsGuids = [];
        this.Hidden = false;
        this.AvailableTasks = [];
        this.AvailableResponses = [];
    }
    return ChannelConfigurationObject;
}());
var GetDevicesListRequest = (function (_super) {
    __extends(GetDevicesListRequest, _super);
    function GetDevicesListRequest() {
        var _this = _super.call(this) || this;
        _this.Resource = "/devices/list";
        _this.Method = Method.Get;
        return _this;
    }
    return GetDevicesListRequest;
}(DataFrame));
//# sourceMappingURL=DevicesService.js.map