var DeviceTaskTypeInfo = (function () {
    function DeviceTaskTypeInfo() {
        this._type = DeviceTaskType.Unknown;
        this._interfaceType = "";
    }
    Object.defineProperty(DeviceTaskTypeInfo.prototype, "Type", {
        get: function () {
            return this._type;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DeviceTaskTypeInfo.prototype, "InterfaceType", {
        get: function () {
            return this._interfaceType;
        },
        set: function (value) {
            this._interfaceType = value;
            this._type = DeviceTaskType[value];
        },
        enumerable: false,
        configurable: true
    });
    return DeviceTaskTypeInfo;
}());
export { DeviceTaskTypeInfo };
export var DeviceTaskType;
(function (DeviceTaskType) {
    DeviceTaskType["Unknown"] = "Unknown";
    DeviceTaskType["SetBlindPosition"] = "IBlindPosition";
    DeviceTaskType["SetBlindMicroventilation"] = "IMicroventilation";
    DeviceTaskType["SetChannelOff"] = "IChannelOff";
    DeviceTaskType["SetChannelOn"] = "IChannelOn";
    DeviceTaskType["TogleState"] = "IChannelSwitchState";
    DeviceTaskType["SetLightBrightnessDynamicly"] = "IDynamicLightBrightness";
    DeviceTaskType["SetLightBrightness"] = "ILightBrightness";
    DeviceTaskType["SetLightColor"] = "ILightColor";
    DeviceTaskType["SetLightWarmth"] = "ILightTemperature";
    DeviceTaskType["PairDevice"] = "IPair";
    DeviceTaskType["UnpairDevice"] = "IUnpair";
    DeviceTaskType["IdentifyDevice"] = "IIdentifyDevice";
    DeviceTaskType["ChaChannelsState"] = "IGetDeviceState";
    DeviceTaskType["GetPowerMeasurements"] = "IGetPowerMeasurements";
    DeviceTaskType["GetAvailableData"] = "IGetAvailableData";
    DeviceTaskType["MultipleDataRequest"] = "IMultipleDataRequest";
    DeviceTaskType["SetBlindOpenCloseTime"] = "ISetBlindOpenCloseTime";
    DeviceTaskType["SetTemperature"] = "IChangeTemperature";
    DeviceTaskType["SetGatePosition"] = "IGatePosition";
    DeviceTaskType["SetGatewayPosition"] = "IGatewayPosition";
    DeviceTaskType["SetFacadePosition"] = "IFacadePosition";
})(DeviceTaskType || (DeviceTaskType = {}));
var DeviceResponseTypeInfo = (function () {
    function DeviceResponseTypeInfo() {
        this._type = DeviceResponseType.Unknown;
        this._interfaceType = "";
    }
    Object.defineProperty(DeviceResponseTypeInfo.prototype, "Type", {
        get: function () {
            return this._type;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(DeviceResponseTypeInfo.prototype, "InterfaceType", {
        get: function () {
            return this._interfaceType;
        },
        set: function (value) {
            this._interfaceType = value;
            this._type = DeviceResponseType[value];
        },
        enumerable: false,
        configurable: true
    });
    return DeviceResponseTypeInfo;
}());
export { DeviceResponseTypeInfo };
export var DeviceResponseType;
(function (DeviceResponseType) {
    DeviceResponseType["Unknown"] = "Unknown";
    DeviceResponseType["BatteryState"] = "IBatteryState";
    DeviceResponseType["BinarySensorState"] = "IBinarySensor";
    DeviceResponseType["BlindOpenCloseTime"] = "IBlindOpenCloseTime";
    DeviceResponseType["BlindPosition"] = "IBlindPosition";
    DeviceResponseType["BlindRemoteButtonState"] = "IBlindsControlButton";
    DeviceResponseType["MeasuredBrightness"] = "IBrightness";
    DeviceResponseType["RemoteButtonState"] = "IButtonState";
    DeviceResponseType["ChannelOnOffState"] = "IChannelOnOff";
    DeviceResponseType["DoorBellState"] = "IDoorBell";
    DeviceResponseType["FacadeRemoteButtonState"] = "IFacadeControlButton";
    DeviceResponseType["FacadePosition"] = "IFacadeState";
    DeviceResponseType["FloodSensorState"] = "IFloodSensor";
    DeviceResponseType["GatePosition"] = "IGatePosition";
    DeviceResponseType["GatewayPosition"] = "IGatewayPosition";
    DeviceResponseType["HumiditySensorState"] = "IHumiditySensor";
    DeviceResponseType["LightBrightness"] = "ILightBrightness";
    DeviceResponseType["LightColor"] = "ILightColor";
    DeviceResponseType["LightWarmth"] = "ILightTemperature";
    DeviceResponseType["LightTreshold"] = "ILightTreshold";
    DeviceResponseType["MovementSensorState"] = "IMovementSensor";
    DeviceResponseType["OnlineCamera"] = "IOnlineCamera";
    DeviceResponseType["OvercurrentProtectionState"] = "IOvercurrentProtection";
    DeviceResponseType["OvercurrentProtectionThreshold"] = "IOvercurrentProtectionThreshold";
    DeviceResponseType["ReedPosition"] = "IReedPosition";
    DeviceResponseType["SignalStrength"] = "ISignalStrength";
    DeviceResponseType["SmokeSensorState"] = "ISmokeSensor";
    DeviceResponseType["MeasuredTemperature"] = "ITemperature";
    DeviceResponseType["VibrationSensorState"] = "IVibrationSensor";
    DeviceResponseType["MeasuredWindSpeed"] = "IWindSpeed";
    DeviceResponseType["WindTreshold"] = "IWindTreshold";
})(DeviceResponseType || (DeviceResponseType = {}));
export var DeviceState;
(function (DeviceState) {
    DeviceState[DeviceState["NotResponding"] = 0] = "NotResponding";
    DeviceState[DeviceState["Working"] = 1] = "Working";
    DeviceState[DeviceState["Broken"] = 2] = "Broken";
    DeviceState[DeviceState["FirmareUpgradeMode"] = 3] = "FirmareUpgradeMode";
})(DeviceState || (DeviceState = {}));
export var CommunicationWay;
(function (CommunicationWay) {
    CommunicationWay[CommunicationWay["TwoWay"] = 1] = "TwoWay";
    CommunicationWay[CommunicationWay["OneWay"] = 2] = "OneWay";
    CommunicationWay[CommunicationWay["ConditionalTwoWay"] = 3] = "ConditionalTwoWay";
})(CommunicationWay || (CommunicationWay = {}));
export var DeviceType;
(function (DeviceType) {
    DeviceType[DeviceType["Unknown"] = -1] = "Unknown";
    DeviceType[DeviceType["Multipurpose"] = 0] = "Multipurpose";
    DeviceType[DeviceType["Controller"] = 1] = "Controller";
    DeviceType[DeviceType["Driver"] = 2] = "Driver";
    DeviceType[DeviceType["Receiver"] = 3] = "Receiver";
    DeviceType[DeviceType["Remote"] = 4] = "Remote";
    DeviceType[DeviceType["Sensor"] = 5] = "Sensor";
    DeviceType[DeviceType["Scene"] = 6] = "Scene";
})(DeviceType || (DeviceType = {}));
//# sourceMappingURL=IDevice.js.map