import { IDeviceState } from './IDeviceState';
import { DeviceTaskExecutionResult } from './TaskExecutionResult';
import { IDeviceTask } from './IDeviceTask';
import { IDeviceResponseTypeInfo, IDeviceTaskTypeInfo } from './IDevice';
export interface IDeviceChannel {
    get Number(): number;
    set Number(value: number);
    get Name(): string;
    set Name(value: string);
    get IconName(): string;
    set IconName(value: string);
    get States(): IDeviceState[];
    set States(value: IDeviceState[]);
    set State(value: IDeviceState);
    get Mode(): ChannelConfigurations;
    get ChannelGroups(): string[];
    get IsHidden(): boolean;
    get AvailableTaskTypes(): IDeviceTaskTypeInfo[];
    get AvailableResponseTypes(): IDeviceResponseTypeInfo[];
    ExecuteTaskAsync(task: IDeviceTask): Promise<DeviceTaskExecutionResult>;
}
export declare enum ChannelConfigurations {
    Default = 0,
    Monostable = 1,
    Bistable = 2,
    Gate = 3,
    Gateway = 4
}
