import { IDIService } from "../../IDIService";
import { ITypedEvent } from "../../TypedEvent";
import { IDevice } from './IDevice';
import { IDeviceState } from './IDeviceState';
export interface IDevicesService extends IDIService {
    OnDeviceRegisteredEvent(): ITypedEvent<IDevice>;
    OnDeviceRemovedEvent(): ITypedEvent<IDevice>;
    OnDeviceFoundEvent(): ITypedEvent<IDevice>;
    OnDeviceStateChangedEvent(): ITypedEvent<[IDevice, IDeviceState]>;
    GetDevicesAsync(): Promise<IDevice[]>;
    SyncDevicesStatesAsync(): Promise<IDeviceState[]>;
    GetDevice(guid: string): IDevice | undefined;
    FindDevicesAsync(device: IDevice): Promise<void>;
    RegisterDeviceAsync(device: IDevice): Promise<void>;
    RemoveDeviceAsync(device: IDevice): Promise<void>;
}
