import { DependencyContainer } from './DependencyContainer';
var TypedEvent = (function () {
    function TypedEvent() {
        this.handlers = [];
    }
    TypedEvent.prototype.Subscribe = function (handler) {
        this.handlers.push(handler);
    };
    TypedEvent.prototype.Unsubscribe = function (handler) {
        this.handlers = this.handlers.filter(function (h) { return h !== handler; });
    };
    TypedEvent.prototype.Invoke = function (data) {
        this.handlers.slice(0).forEach(function (h) {
            var _a;
            try {
                h(data);
            }
            catch (ex) {
                (_a = DependencyContainer.Log) === null || _a === void 0 ? void 0 : _a.Error(ex);
            }
        });
    };
    return TypedEvent;
}());
export { TypedEvent };
//# sourceMappingURL=TypedEvent.js.map